package knearestneighborballtreeopt;

public class Distance {
	public static double distance(Instance first, Instance second) {
		return Math.sqrt(distanceSq(first, second));
	}
	
	public static double distanceSq(Instance first, Instance second) {
		double sum = 0.;
		int dim = first.numValues();
		for (int i = 0; i < dim; i++) {
			double diff = first.value(i) - second.value(i);
			sum += diff * diff;
		}
		return sum;
	}
}
